package mx.italika.prod.italika.model.entity;

import java.time.Instant;
import java.util.LinkedHashSet;
import java.util.Set;

import org.hibernate.annotations.ColumnDefault;

import jakarta.persistence.Column;
import jakarta.persistence.Entity;
import jakarta.persistence.GeneratedValue;
import jakarta.persistence.GenerationType;
import jakarta.persistence.Id;
import jakarta.persistence.OneToMany;
import jakarta.persistence.Table;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@Entity
@Table(name = "c_rol")
public class RolEntity {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id_rol", nullable = false)
    private Integer id;

    @Column(name = "clave", nullable = false, length = 50)
    private String clave;

    @Column(name = "nombre", nullable = false, length = 150)
    private String nombre;

    @ColumnDefault("CURRENT_TIMESTAMP")
    @Column(name = "fecha_alta")
    private Instant fechaAlta;

    @Column(name = "fecha_baja")
    private Instant fechaBaja;

    @Column(name = "fecha_modifica")
    private Instant fechaModifica;

    @Column(name = "es_global")
    private Boolean esGlobal;

    @OneToMany(mappedBy = "idRol")
    private Set<UsuarioRolEntity> tblUsuarioRols = new LinkedHashSet<>();

}