package mx.italika.prod.italika.service;

import org.springframework.http.ResponseEntity;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.stereotype.Service;

import mx.italika.prod.italika.config.JwtService;
import mx.italika.prod.italika.model.LoginRecord;
import mx.italika.prod.italika.model.bean.ResponseBean;
import mx.italika.prod.italika.model.bean.UsuarioBean;
import mx.italika.prod.italika.model.entity.UsuarioEntity;
import mx.italika.prod.italika.repository.UsuarioRepository;

@Service
public class UsuarioServiceimpl implements UserDetailsService {

	private UsuarioRepository usuarioRepository;

	JwtService jwtService;

	public UsuarioServiceimpl(UsuarioRepository usuarioRepository, JwtService jwtService  ) {
		this.usuarioRepository = usuarioRepository;
        this.jwtService = jwtService;
	}

	@Override
	public UsuarioBean loadUserByUsername(String username) throws UsernameNotFoundException {
		    UsuarioEntity usuarioEntity = usuarioRepository.findByUsername(username)
		        .orElseThrow(() -> new UsernameNotFoundException("Usuario no encontrado: " + username));		    
		    return new UsuarioBean(usuarioEntity);

	}

	public ResponseEntity<?> login(UsuarioBean usuarioBean) {

		try {
			UsuarioBean responseBean = loadUserByUsername(usuarioBean.getUsername());

			String token = jwtService.generateToken(responseBean);
			LoginRecord loginRecord = new LoginRecord(token, null);

			 return ResponseEntity.ok(new ResponseBean<>("success", 200, "Inicio de sesión exitoso", loginRecord));
		} catch (UsernameNotFoundException e) {

			return ResponseEntity.badRequest().body( new ResponseBean<>("error", 901, "Error al iniciar sesión", null));
		}

	}
}
